<<< Date Index >>>     <<< Thread Index >>>

[PATCH] Include extra information in mutt version string for developer builds



Take 2.  Includes Moritz Barsnick's changes and simulates {latesttag}
when running in a Mercurial release that does not have it, per Christian
Ebert.


# HG changeset patch
# User David Champion <dgc@xxxxxxxxxxxx>
# Date 1284678222 18000
# Branch HEAD
# Node ID c16ee46e288f86a297e014d65d277b9d6a0d22c0
# Parent  59aad6c21703484a9a298536efd4d971039d0a61
Include extra information in mutt version string for developer builds.

When a build is based on an hg clone, include extra information about
the changeset node, distance from a tagged release, and mq applied patch
count.

For example, after this patch is applied my mutt build identifies itself
(in mutt -v and in <show-version>) as:

Mutt 1.5.21+26,mq+22 (7edc2073390d) (2010-09-15)

I have applied 26 changesets applied since 1.5.21 was tagged, 22 of
which are in my mq patch series.  A 1.5.21 release build that is not
mercurial-based would still appear simply as "1.5.21".

diff -r 59aad6c21703 -r c16ee46e288f configure.ac
--- a/configure.ac      Wed Sep 15 11:47:39 2010 -0700
+++ b/configure.ac      Thu Sep 16 18:03:42 2010 -0500
@@ -7,7 +7,7 @@
 AC_INIT([mutt.h])
 AM_CONFIG_HEADER([config.h])
 
-mutt_cv_version=`cat $srcdir/VERSION`
+mutt_cv_version=`./version`
 AM_INIT_AUTOMAKE(mutt, $mutt_cv_version)
 AC_SUBST([CONFIG_STATUS_DEPENDENCIES], ['$(top_srcdir)/VERSION'])
 
diff -r 59aad6c21703 -r c16ee46e288f version
--- /dev/null   Thu Jan 01 00:00:00 1970 +0000
+++ b/version   Thu Sep 16 18:03:42 2010 -0500
@@ -0,0 +1,60 @@
+#!/bin/sh
+
+# Ensure that we have a repo here and that mercurial is installed.  If
+# not, just cat the VERSION file; it contains the latest release number.
+{ [ -d .hg ] && hg >/dev/null 2>&1; } || { cat VERSION; exit 0; }
+
+# This is a mercurial repo and we have the hg command.
+
+# Get essential properties of the current working copy
+set -- $(hg parents --template='{rev} {node|short}\n')
+rev="$1"
+node="$2"
+
+# translate release tags into ##.##.## notation
+cleantag () {
+       case "$1" in
+               mutt-*-rel) echo "$1" | sed -e 's/mutt-//' -e 's/-rel//' | tr - 
. ;;
+               *)          echo "$1" ;;
+       esac
+}
+
+getdistance_old () {
+       # fudge it
+       tmp=$(hg tags | sort -n +1 | egrep 'mutt-.*rel' | tail -1 | cut -d: -f1)
+       latesttag=$(echo $tmp | awk '{print $1}')
+       latestrev=$(echo $tmp | awk '{print $2}')
+       distance=$(($rev - $latestrev))
+       echo $latesttag $distance
+}
+
+getdistance_new () {
+       hg parents --template='{latesttag} {latesttagdistance}\n'
+}
+
+
+# latesttag appeared in hg 1.4.  Test for it.
+[ "$(hg log -r . --template='{latesttag}')" = '' ] && 
+set -- $(getdistance_old) ||
+set -- $(getdistance_new)
+
+tag=$(cleantag "$1")
+dist=$2
+
+if [ $dist -eq 0 ]; then
+       dist=
+else
+       dist="+$dist"
+fi
+
+# if we have mq patches applied, mention it
+qparent=$(hg log -r qparent --template='{rev}\n' 2>/dev/null || echo $rev)
+qdelta=$(expr $rev - $qparent)
+if [ $qdelta -eq 0 ]; then
+       qdist=""
+else
+       qdist=",mq+$qdelta"
+fi
+
+echo "$tag$dist$qdist ($node)"
+exit 0